﻿Imports System.Data
Imports System.Data.OleDb

Partial Public Class ViewWebboard
    Inherits System.Web.UI.Page

    Protected objConn As OleDbConnection
    Protected strQuestionID As String = HttpContext.Current.Request.QueryString("QuestionID")
    Protected strReplyNo As Integer = 1

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim strConnString As String
        strConnString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=|DataDirectory|\database.mdb"
        objConn = New OleDbConnection(strConnString)
        objConn.Open()

        ShowQuestion()
        ShowReply()

    End Sub

    Protected Sub ShowQuestion()
        Dim dtAdapter As OleDbDataAdapter
        Dim objCmd As OleDbCommand
        Dim dt As New DataTable
        Dim strSQL As New StringBuilder
        strSQL.Append("SELECT * FROM webboard ")
        strSQL.Append(" WHERE QuestionID = " & strQuestionID & " ")
        dtAdapter = New OleDbDataAdapter(strSQL.ToString, objConn)
        dtAdapter.Fill(dt)

        If dt.Rows.Count > 0 Then
            Me.lblQuestion.Text = dt.Rows(0)("Question")
            Me.lblDetails.Text = dt.Rows(0)("Details")
            Me.lblName.Text = "<b>Name : </b>" & dt.Rows(0)("Name")
            Me.lblCreateDate.Text = "<b>CreateDate : </b>" & CDate(dt.Rows(0)("CreateDate")).ToString("dd/MM/yyyy HH:mm")
            Me.lblReply.Text = "<b>Reply : </b>" & dt.Rows(0)("Reply")
            Me.lblView.Text = "<b>View : </b>" & dt.Rows(0)("View")
        End If

        '*** Update Number of View ***'
        strSQL.Remove(0, strSQL.Length)
        strSQL.Append(" UPDATE webboard SET [View] = [View] + 1 ")
        strSQL.Append(" WHERE QuestionID = @sQuestionID ")
        objCmd = New OleDbCommand(strSQL.ToString(), objConn)
        objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString()
        objCmd.ExecuteNonQuery()

    End Sub

    Protected Sub ShowReply()

        Dim strSQL As New StringBuilder
        Dim objCmd As OleDbCommand

        strSQL.Append(" SELECT * FROM reply ")
        strSQL.Append(" WHERE QuestionID = " & strQuestionID & " ")

        Dim dtReader As OleDbDataReader
        objCmd = New OleDbCommand(strSQL.ToString, objConn)
        dtReader = objCmd.ExecuteReader()

        '*** BindData to Repeater ***'
        myRepeater.DataSource = dtReader
        myRepeater.DataBind()

        dtReader.Close()
        dtReader = Nothing

    End Sub

    Protected Sub ViewWebboard_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload

        objConn.Close()
        objConn = Nothing

    End Sub


    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSave.Click

        Dim strSQL As New StringBuilder
        Dim objCmd As OleDbCommand

        '*** Insert Reply ***'
        strSQL.Append(" INSERT INTO reply (QuestionID,CreateDate,Details,Name) ")
        strSQL.Append(" VALUES ")
        strSQL.Append(" (@sQuestionID,@sCreateDate,@sDetails,@sName) ")
        objCmd = New OleDbCommand(strSQL.ToString(), objConn)
        objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString()
        objCmd.Parameters.Add("@sCreateDate", OleDbType.Date).Value = Now()
        objCmd.Parameters.Add("@sDetails", OleDbType.VarChar).Value = Me.txtDetails.Text
        objCmd.Parameters.Add("@sName", OleDbType.VarChar).Value = Me.txtName.Text
        objCmd.ExecuteNonQuery()

        '*** Update Number of Reply ***'
        strSQL.Remove(0, strSQL.Length)
        strSQL.Append(" UPDATE webboard SET Reply = Reply + 1 ")
        strSQL.Append(" WHERE QuestionID = @sQuestionID ")
        objCmd = New OleDbCommand(strSQL.ToString(), objConn)
        objCmd.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = strQuestionID.ToString()
        objCmd.ExecuteNonQuery()

        Response.Redirect("ViewWebboard.aspx?QuestionID=" & strQuestionID)

    End Sub

    Protected Sub myRepeater_ItemDataBound(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.RepeaterItemEventArgs) Handles myRepeater.ItemDataBound
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then

            '*** No ***'
            Dim lblReplyNo As Label = DirectCast(e.Item.FindControl("lblReplyNo"), Label)
            If Not IsNothing(lblReplyNo) Then
                lblReplyNo.Text = "No : " & strReplyNo
                strReplyNo = strReplyNo + 1
            End If

            '*** Details ***'
            Dim lblReplyDetails As Label = DirectCast(e.Item.FindControl("lblReplyDetails"), Label)
            If Not IsNothing(lblReplyDetails) Then
                lblReplyDetails.Text = e.Item.DataItem("Details")
            End If

            '*** Name ***'
            Dim lblReplyName As Label = DirectCast(e.Item.FindControl("lblReplyName"), Label)
            If Not IsNothing(lblReplyName) Then
                lblReplyName.Text = e.Item.DataItem("Name")
            End If

            '*** CreateDate ***'
            Dim lblReplyCreateDate As Label = DirectCast(e.Item.FindControl("lblReplyCreateDate"), Label)
            If Not IsNothing(lblReplyCreateDate) Then
                lblReplyCreateDate.Text = CDate(e.Item.DataItem("CreateDate")).ToString("dd/MM/yyyy HH:mm")
            End If

        End If
     
    End Sub

End Class